VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFtpFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Encaps
Private m_DisplayName As String
Private m_Attribs As Long
Private m_ParentFolder As CFtpFolder
Private m_ParentServer As CFtpServer

' Constants
Private Const OP_DOWNLOAD As Long = &H1
Private Const OP_READ As Long = &H2
Private Const OP_WRITE As Long = &H3


' ***************************************************************************************
' Init/Fin
' ***************************************************************************************
Friend Sub CreateFromFindData(ByRef fd As TWin32FindData)
On Error GoTo hell
    m_DisplayName = NullTrim(fd.szFileName)
    m_Attribs = fd.dwFileAttributes
    Exit Sub
hell:
End Sub
Friend Sub CreateFromXmlNode(ByVal xn As CXMLNode)
On Error GoTo hell
    m_DisplayName = xn.Attributes("displayname").Value
    m_Attribs = CLng(xn.Attributes("attribs").Value)
    Exit Sub
hell:
End Sub
Friend Sub SetParentFolder(ByVal parent As CFtpFolder)
On Error GoTo hell
    Set m_ParentFolder = parent
    Exit Sub
hell:
End Sub
Friend Sub SetParentServer(ByVal parent As CFtpServer)
On Error GoTo hell
    Set m_ParentServer = parent
    Exit Sub
hell:
End Sub
Friend Sub Dispose()
On Error GoTo hell
    ' cancel operations
    ' ...
    ' resolve circs
    Set m_ParentFolder = Nothing
    Set m_ParentServer = Nothing
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Properties
' ***************************************************************************************
Public Property Get DisplayName() As String
On Error GoTo hell
    DisplayName = m_DisplayName
    Exit Property
hell:
End Property
Public Property Get Attributes() As Long
On Error GoTo hell
    Attributes = m_Attribs
    Exit Property
hell:
End Property
Public Property Get IconIndex(Optional ByVal fOpen As Boolean = False, Optional ByVal fLarge As Boolean = False) As Long
On Error GoTo hell
    IconIndex = GetSystemIconIndex(m_DisplayName, fOpen, fLarge, True)
    Exit Property
hell:
End Property
Public Property Get ParentFolder() As CFtpFolder
On Error GoTo hell
    Set ParentFolder = m_ParentFolder
    Exit Property
hell:
End Property
Public Property Get ParentServer() As CFtpServer
On Error GoTo hell
    Set ParentServer = m_ParentServer
    Exit Property
hell:
End Property
Public Property Get FullUrl() As String
On Error GoTo hell
    With m_ParentServer.Url
        FullUrl = PROT_FTP & .Host & Me.FullPath
    End With
    Exit Property
hell:
End Property
Public Property Get FullPath() As String
On Error GoTo hell
    FullPath = m_ParentFolder.FullPath & m_DisplayName
    Exit Property
hell:
End Property


' ***************************************************************************************
' Callbacks
' ***************************************************************************************
Friend Sub InetStatusCallback(ByVal status As CStatusInfo)
On Error GoTo hell
    If Not InetConnection.StatusCallback Is Nothing Then
        ' fil notification
        Select Case status.InternetStatus
            Case InternetStates.HandleClosing
                Select Case status.Context.Operation
                    Case OP_DOWNLOAD
                        InetConnection.StatusCallback.FtpFileDownloaded status
                End Select
            Case InternetStates.StateChange
                ' ...
        End Select
    End If
    Exit Sub
hell:
End Sub
Public Function GetFile(ByVal sTargetFile As String, Optional ByVal transfer As FtpTransferModes = FtpTransferModes.Binary) As Boolean
    ' sensible user info?
    If m_ParentServer.QueryUserInfo = False Then GoTo hell
    ' busy
    If Not InetConnection.StatusCallback Is Nothing Then InetConnection.StatusCallback.BusyState True, "Downloading file " & Me.FullUrl & " ..."
    ' connected?
    If InetConnection.AttemptConnect = False Then GoTo hell
    ' get temp handle
    Dim hFtpTemp As Long: hFtpTemp = m_ParentServer.GetFtpHandle
    If hFtpTemp = 0 Then InternetRaiseError FtpServerNotConnected
    ' change dir
    If FtpSetCurrentDirectory(hFtpTemp, SLASH) = 0 Then InternetRaiseError FtpFolderOperationFailed
    If FtpSetCurrentDirectory(hFtpTemp, SLASH) = 0 Then InternetRaiseError FtpFolderOperationFailed
On Error GoTo hell
    Dim ret As Long
    ret = FtpGetFile(hFtpTemp, Me.FullPath, sTargetFile, ApiBool.ApiFalse, 0&, InternetFlags.Reload Or InternetFlags.NoCacheWrite Or transfer, GetContextID(OP_DOWNLOAD))
    GetFile = (ret <> 0)
    GoTo finally
hell:
finally:
On Error Resume Next
    InternetCloseHandle hFtpTemp
    If Not InetConnection.StatusCallback Is Nothing Then InetConnection.StatusCallback.BusyState False
End Function
Friend Sub Persist(ByVal xnParent As CXMLNode)
On Error GoTo hell
    Dim xn As CXMLNode
    Set xn = xnParent.SubNodes.Add("ftpfile")
    xn.Attributes.Add "displayname", m_DisplayName
    xn.Attributes.Add "attribs", CStr(m_Attribs)
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Helpers
' ***************************************************************************************
Private Function GetContextID(ByVal dwOperation As Long) As Long
On Error GoTo hell
    Select Case dwOperation
        Case OP_DOWNLOAD
            GetContextID = InetConnection.Contexts.Add(m_ParentServer, m_ParentFolder, Me, dwOperation)
    End Select
    Exit Function
hell:
End Function

