VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFtpFolder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Encaps
Private m_DisplayName As String
Private m_Attribs As Long
Private m_ParentFolder As CFtpFolder
Private m_ParentServer As CFtpServer
Private m_IsUpdated As Boolean
Private m_Folders As NFtpFolders
Private m_Files As NFtpFiles

' Constants
Private Const OP_UPDATE As Long = &H1
Private Const OP_UPLOAD As Long = &H2


' ***************************************************************************************
' Init/Fin
' ***************************************************************************************
Private Sub Class_Initialize()
On Error GoTo hell
    Set m_Folders = New NFtpFolders
    Set m_Files = New NFtpFiles
    Exit Sub
hell:
End Sub
Friend Sub CreateAsRoot()
On Error GoTo hell
    m_DisplayName = "/"
    Exit Sub
hell:
End Sub
Friend Sub CreateFromFindData(ByRef fd As TWin32FindData)
On Error GoTo hell
    m_DisplayName = NullTrim(fd.szFileName): PathAssertEndSlash m_DisplayName
    m_Attribs = fd.dwFileAttributes
    Exit Sub
hell:
End Sub
Friend Sub CreateFromXmlNode(ByVal xn As CXMLNode)
On Error GoTo hell
    m_DisplayName = xn.Attributes("displayname").Value
    m_Attribs = CLng(xn.Attributes("attribs").Value)
    Dim xnSub As CXMLNode
    For Each xnSub In xn.SubNodes
        Select Case xnSub.Name
            Case "ftpfolder"
                m_Folders.AddFromXmlNode Me, xnSub
            Case "ftpfile"
                m_Files.AddFromXmlNode Me, xnSub
        End Select
    Next xnSub
    Exit Sub
hell:
End Sub
Friend Sub SetParentFolder(ByVal parent As CFtpFolder)
On Error GoTo hell
    Set m_ParentFolder = parent
    Exit Sub
hell:
End Sub
Friend Sub SetParentServer(ByVal parent As CFtpServer)
On Error GoTo hell
    Set m_ParentServer = parent
    Exit Sub
hell:
End Sub
Friend Sub Dispose()
On Error GoTo hell
    ' cancel all operations
    ' ....
    ' resolve circs
    Set m_ParentFolder = Nothing
    Set m_ParentServer = Nothing
    ' walk sub folders and files
    Dim fdr As CFtpFolder, fil As CFtpFile
    For Each fdr In Me.Folders
        fdr.Dispose ' recurse
    Next fdr
    For Each fil In Me.Files
        fil.Dispose
    Next fil
    Me.Folders.Clear
    Me.Files.Clear
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Properties
' ***************************************************************************************
Public Property Get DisplayName() As String
On Error GoTo hell
    DisplayName = m_DisplayName
    Exit Property
hell:
End Property
Public Property Get Attributes() As Long
On Error GoTo hell
    Attributes = m_Attribs
    Exit Property
hell:
End Property
Public Property Get IconIndex(Optional ByVal fOpen As Boolean = False, Optional ByVal fLarge As Boolean = False) As Long
On Error GoTo hell
    If fOpen = True Then
                IconIndex = 4
        Else:   IconIndex = 3
    End If
    Exit Property
hell:
End Property
Public Property Get ParentFolder() As CFtpFolder
On Error GoTo hell
    Set ParentFolder = m_ParentFolder
    Exit Property
hell:
End Property
Public Property Get ParentServer() As CFtpServer
On Error GoTo hell
    Set ParentServer = m_ParentServer
    Exit Property
hell:
End Property
Public Property Get Folders() As NFtpFolders
On Error GoTo hell
    Set Folders = m_Folders
    Exit Property
hell:
End Property
Public Property Get Files() As NFtpFiles
On Error GoTo hell
    Set Files = m_Files
    Exit Property
hell:
End Property
Public Property Get IsUpdated() As Boolean
On Error GoTo hell
    IsUpdated = m_IsUpdated
    Exit Property
hell:
End Property
Public Property Get FullUrl() As String
On Error GoTo hell
    With m_ParentServer.Url
        FullUrl = PROT_FTP & .Host & Me.FullPath
    End With
    Exit Property
hell:
End Property
Public Property Get FullPath() As String
On Error GoTo hell
    Dim fdr As CFtpFolder: Set fdr = Me
    Dim sDir As String, sMore As String
    Do Until fdr Is Nothing
        sMore = fdr.DisplayName
        PathAssertEndSlash sMore
        sDir = sMore & sDir
        Set fdr = fdr.ParentFolder
    Loop
    FullPath = sDir
    Exit Property
hell:
End Property


' ***************************************************************************************
' Methods
' ***************************************************************************************
Public Function Update() As Boolean
    ' sensible user info?
    If m_ParentServer.QueryUserInfo = False Then GoTo hell
    ' busy
    If Not InetConnection.StatusCallback Is Nothing Then InetConnection.StatusCallback.BusyState True, "Updating folder " & Me.FullUrl & " ..."
    ' connected?
    If InetConnection.AttemptConnect = False Then GoTo hell
    ' get temp handle
    Dim hFtpTemp As Long: hFtpTemp = m_ParentServer.GetFtpHandle
    If hFtpTemp = 0 Then InternetRaiseError FtpServerNotConnected
    ' busy
    If Not InetConnection.StatusCallback Is Nothing Then InetConnection.StatusCallback.BusyState True, "Updating folder " & Me.FullUrl & " ..."
    ' change dir
    If FtpSetCurrentDirectory(hFtpTemp, SLASH) = 0 Then InternetRaiseError FtpFolderOperationFailed
    If FtpSetCurrentDirectory(hFtpTemp, Me.FullPath) = 0 Then InternetRaiseError FtpFolderOperationFailed
On Error GoTo hell
    ' reset
    m_Folders.Clear
    m_Files.Clear
    m_IsUpdated = False
    ' search path
    Dim sPath As String: sPath = Me.FullPath
    PathAppend sPath, WILDCARD ' ...
    ' allocate
    Dim fd As TWin32FindData
    ' start
    Dim ret As Long, hFind As Long, sFileName As String
    hFind = FtpFindFirstFile(hFtpTemp, sPath, fd, _
                            InternetFlags.Reload Or InternetFlags.NoCacheWrite, _
                            GetContextID(OP_UPDATE))
    If hFind <> 0 Then
        Do
            ' add
            sFileName = NullTrim(fd.szFileName)
            If sFileName <> DOT And sFileName <> DOTS Then
                If CBool(fd.dwFileAttributes And FileAttributes.Directory) Then
                            m_Folders.AddFromFindData Me, fd
                    Else
                            m_Files.AddFromFindData Me, fd
                End If
            End If
            ' next
            ret = InternetFindNextFile(hFind, fd)
        Loop While ret <> 0
    End If
    Update = True
    GoTo finally
hell:
finally:
On Error Resume Next
    InternetCloseHandle hFind
    InternetCloseHandle hFtpTemp
    If Not InetConnection.StatusCallback Is Nothing Then InetConnection.StatusCallback.BusyState False
End Function
Public Function PutFile(ByVal sSourceFile As String, ByVal sTargetFileName As String, Optional ByVal transfer As FtpTransferModes = FtpTransferModes.Binary) As Boolean
    ' sensible user info?
    If m_ParentServer.QueryUserInfo = False Then GoTo hell
    ' busy
    If Not InetConnection.StatusCallback Is Nothing Then InetConnection.StatusCallback.BusyState True, "Uploading file " & sTargetFileName & " to " & Me.FullUrl & " ..."
    ' connected?
    If InetConnection.AttemptConnect = False Then GoTo hell
    ' get temp handle
    Dim hFtpTemp As Long: hFtpTemp = m_ParentServer.GetFtpHandle
    If hFtpTemp = 0 Then InternetRaiseError FtpServerNotConnected
    ' change dir
    If FtpSetCurrentDirectory(hFtpTemp, SLASH) = 0 Then InternetRaiseError FtpFolderOperationFailed
    If FtpSetCurrentDirectory(hFtpTemp, Me.FullPath) = 0 Then InternetRaiseError FtpFolderOperationFailed
On Error GoTo hell
    Dim ret As Long
    ret = FtpPutFile(hFtpTemp, sSourceFile, Me.FullPath & sTargetFileName, transfer, GetContextID(OP_UPLOAD))
    PutFile = (ret <> 0)
    GoTo finally
hell:
finally:
On Error Resume Next
    InternetCloseHandle hFtpTemp
    Me.Update ' ... think about it
    If Not InetConnection.StatusCallback Is Nothing Then InetConnection.StatusCallback.BusyState False
End Function
Friend Sub Persist(ByVal xnParent As CXMLNode)
On Error GoTo hell
    Dim xn As CXMLNode, subfolder As CFtpFolder, subfile As CFtpFile
    Set xn = xnParent.SubNodes.Add("ftpfolder")
    xn.Attributes.Add "displayname", m_DisplayName
    xn.Attributes.Add "attribs", CStr(m_Attribs)
    For Each subfolder In m_Folders
        subfolder.Persist xn
    Next subfolder
    For Each subfile In m_Files
        subfile.Persist xn
    Next subfile
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Callbacks
' ***************************************************************************************
Friend Sub InetStatusCallback(ByVal status As CStatusInfo)
On Error GoTo hell
    If Not InetConnection.StatusCallback Is Nothing Then
        ' folder notification
        Select Case status.InternetStatus
            Case InternetStates.HandleClosing
                Select Case status.Context.Operation
                    Case OP_UPDATE
                        m_IsUpdated = True
                        InetConnection.StatusCallback.FtpFolderUpdated status
                    Case OP_UPLOAD
                        InetConnection.StatusCallback.FtpFolderFileUploaded status
                End Select
            Case InternetStates.StateChange
                ' ...
        End Select
        ' map callbacks to file
        If Not status.Context.FtpFile Is Nothing Then
            status.Context.FtpFile.InetStatusCallback status
        End If
    End If
    Exit Sub
hell:
End Sub
Private Function GetContextID(ByVal dwOperation As Long) As Long
On Error GoTo hell
    Select Case dwOperation
        Case OP_UPDATE, OP_UPLOAD
            GetContextID = InetConnection.Contexts.Add(m_ParentServer, Me, , dwOperation)
    End Select
    Exit Function
hell:
End Function

