VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFtpServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Encaps
Private m_Url As CUrl
Private m_Flags As InternetFlags
Private m_Handle As Long
Private m_ParentInetConnection As CInetConnection
Private m_RootFolder As CFtpFolder
Private m_FriendlyName As String
Private m_Description As String

' Constants
Private Const OP_CONNECT As Long = &H1
Private Const OP_CONNECT_TEMP As Long = &H2


' ***************************************************************************************
' Init/Fin
' ***************************************************************************************
Private Sub Class_Initialize()
On Error GoTo hell
    m_Flags = InternetFlags.ExistingConnect Or InternetFlags.Passive
    Exit Sub
hell:
End Sub
Friend Sub CreateFromUrl(ByVal locator As CUrl)
    If locator.Scheme <> InternetSchemes.Ftp Then InternetRaiseError FtpServerInvalidProtocol
On Error GoTo hell
    Set m_Url = locator
    Set m_RootFolder = New CFtpFolder
    m_RootFolder.CreateAsRoot
    m_RootFolder.SetParentServer Me
    Exit Sub
hell:
End Sub
Friend Sub CreateFromXmlNode(ByVal xn As CXMLNode)
On Error GoTo hell
    Dim xnSub As CXMLNode, server As CFtpServer
    m_FriendlyName = xn.Attributes("friendlyname").Value
    m_Description = xn.Attributes("description").Value
    For Each xnSub In xn.SubNodes
        Select Case xnSub.Name
            Case "url"
                Set m_Url = New CUrl
                m_Url.CreateFromXmlNode xnSub
                If m_Url.Scheme <> InternetSchemes.Ftp Then
                    On Error GoTo 0
                    InternetRaiseError FtpServerInvalidProtocol
                End If
            Case "ftpfolder"
                Set m_RootFolder = New CFtpFolder
                m_RootFolder.SetParentServer Me
                m_RootFolder.CreateFromXmlNode xnSub
        End Select
    Next xnSub
    Exit Sub
hell:
End Sub
Friend Sub SetParentInetConnedtion(ByVal parent As CInetConnection)
On Error GoTo hell
    Set m_ParentInetConnection = parent
    Exit Sub
hell:
End Sub
Friend Sub Dispose()
On Error GoTo hell
    ' close connection
    If m_Handle <> 0 Then
        Me.Disconnect
    End If
    ' resolve circs
    Set m_ParentInetConnection = Nothing
    ' dispose folders and files
    m_RootFolder.Dispose
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Properties
' ***************************************************************************************
Public Property Get Url() As CUrl
On Error GoTo hell
    Set Url = m_Url
    Exit Property
hell:
End Property
Public Property Get Flags() As InternetFlags
On Error GoTo hell
    Flags = m_Flags
    Exit Property
hell:
End Property
Public Property Let Flags(argFlags As InternetFlags)
On Error GoTo hell
    m_Flags = argFlags
    Exit Property
hell:
End Property
Public Property Get Handle() As Long
On Error GoTo hell
    Handle = m_Handle
    Exit Property
hell:
End Property
Public Property Get ParentInetConnection() As CInetConnection
On Error GoTo hell
    Set ParentInetConnection = m_ParentInetConnection
    Exit Property
hell:
End Property
Public Property Get Rootfolder() As CFtpFolder
On Error GoTo hell
    Set Rootfolder = m_RootFolder
    Exit Property
hell:
End Property
Public Property Get FriendlyName() As String
On Error GoTo hell
    FriendlyName = m_FriendlyName
    Exit Property
hell:
End Property
Public Property Let FriendlyName(strFriendlyName As String)
On Error GoTo hell
    m_FriendlyName = strFriendlyName
    Exit Property
hell:
End Property
Public Property Get Description() As String
On Error GoTo hell
    Description = m_Description
    Exit Property
hell:
End Property
Public Property Let Description(strDescription As String)
On Error GoTo hell
    m_Description = strDescription
    Exit Property
hell:
End Property


' ***************************************************************************************
' Methods
' ***************************************************************************************
Public Sub Connect()
    ' check
    If m_ParentInetConnection.Handle = 0 Then m_ParentInetConnection.Connect
    If m_ParentInetConnection.Handle = 0 Then InternetRaiseError InternetServicesInaccessible
On Error GoTo hell
    ' connect
    If m_Handle = 0 Then
        m_Handle = Me.GetFtpHandle(m_Flags)
        If m_Handle <> 0 Then
            If Not InetConnection.StatusCallback Is Nothing Then
                InetConnection.StatusCallback.FtpServerConnected Me
            End If
        End If
    End If
    Exit Sub
hell:
End Sub
Public Sub Disconnect()
On Error GoTo hell
    ' close
    If m_Handle <> 0 Then
        MApiInternet.InternetCloseHandle m_Handle
        m_Handle = 0
    End If
    ' notify parent
    m_ParentInetConnection.ShouldDisconnect
    Exit Sub
hell:
End Sub
Friend Function GetFtpHandle(Optional ByVal dwFlags As InternetFlags = InternetFlags.ExistingConnect Or InternetFlags.Passive) As Long
    If m_ParentInetConnection.Handle = 0 Then m_ParentInetConnection.Connect
    If m_ParentInetConnection.Handle = 0 Then InternetRaiseError InternetNotConnected
On Error GoTo hell
    ' user stuff
    Dim sUserName As String, sPassword As String
    If Not m_Url.CurrentUser Is Nothing Then
        sUserName = m_Url.CurrentUser.UserName
        sPassword = m_Url.CurrentUser.Password
    End If
    ' busy
    If Not InetConnection.StatusCallback Is Nothing Then InetConnection.StatusCallback.BusyState True, "Connecting to FTP server " & Me.Url.Host & " ..."
    ' connect
    If sUserName = "" Then
        GetFtpHandle = InternetConnect(m_ParentInetConnection.Handle, m_Url.Host, InternetPorts.DefaultFtp, vbNullString, vbNullString, InternetServices.Ftp, dwFlags, GetContextID(OP_CONNECT_TEMP))
    ElseIf sPassword = "" Then
        GetFtpHandle = InternetConnect(m_ParentInetConnection.Handle, m_Url.Host, InternetPorts.DefaultFtp, sUserName, vbNullString, InternetServices.Ftp, dwFlags, GetContextID(OP_CONNECT_TEMP))
    Else
        GetFtpHandle = InternetConnect(m_ParentInetConnection.Handle, m_Url.Host, InternetPorts.DefaultFtp, sUserName, sPassword, InternetServices.Ftp, dwFlags, GetContextID(OP_CONNECT_TEMP))
    End If
    GoTo finally
hell:
finally:
On Error Resume Next
    If Not InetConnection.StatusCallback Is Nothing Then InetConnection.StatusCallback.BusyState False
End Function
Public Function QueryUserInfo(Optional ByVal fShowAlways As Boolean) As Boolean
On Error GoTo hell
    QueryUserInfo = True ' assume success
    If fShowAlways = False Then
        If Not m_Url.CurrentUser Is Nothing Then
            If Not (m_Url.CurrentUser.UserName = "" Eqv m_Url.CurrentUser.Password = "") Then
                fShowAlways = True
            End If
        End If
    End If
    If fShowAlways = True Then
        QueryUserInfo = m_Url.ShowUserDialog
    End If
    Exit Function
hell:
End Function
Friend Sub Persist(ByVal xnParent As CXMLNode)
On Error GoTo hell
    Dim xn As CXMLNode
    Set xn = xnParent.SubNodes.Add("ftpserver")
    xn.Attributes.Add "friendlyname", m_FriendlyName
    xn.Attributes.Add "description", m_Description
    m_Url.Persist xn
    m_RootFolder.Persist xn
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Callbacks
' ***************************************************************************************
Friend Sub InetStatusCallback(ByVal status As CStatusInfo)
On Error GoTo hell
    ' server notification
    Select Case status.InternetStatus
        Case InternetStates.ConnectedToServer
            If (InetConnection.AccessFlags And InternetAccessFlags.Async) = InternetAccessFlags.Async Then
                If m_Handle <> 0 Then
                    InetConnection.StatusCallback.FtpServerConnected status
                End If
            End If
        Case Else
            ' ...
    End Select
    ' map callbacks to folder
    If Not status.Context.FtpFolder Is Nothing Then
        status.Context.FtpFolder.InetStatusCallback status
    End If
    Exit Sub
hell:
End Sub
Private Function GetContextID(ByVal dwOperation As Long) As Long
On Error GoTo hell
    GetContextID = InetConnection.Contexts.Add(Me, , , dwOperation)
    Exit Function
hell:
End Function
