VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CInetConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' Encaps
Private m_StatusCallback As IStatusCallback
Private m_UserAgent As String
Private m_Proxy As String
Private m_ProxyByPass As String
Private m_AccessType As InternetAccessTypes
Private m_AccessFlags As InternetAccessFlags
Private m_Handle As Long
Private m_Contexts As NContexts
Private m_FtpServers As NFtpServers


' ***************************************************************************************
' Init/Fin
' ***************************************************************************************
Private Sub Class_Initialize()
On Error GoTo hell
    m_UserAgent = "VBInet"
    m_AccessType = InternetAccessTypes.PreConfig
    m_AccessFlags = InternetAccessFlags.None
    Set m_Contexts = New NContexts
    Set m_FtpServers = New NFtpServers
    Exit Sub
hell:
End Sub
Public Sub Dispose()
On Error GoTo hell
    ' close all connections
    Me.Disconnect
    ' dipose servers
    Dim server As CFtpServer
    For Each server In Me.FtpServers
        server.Dispose
    Next server
    Me.FtpServers.Clear
    ' reset
    MInet.Dispose
    ' context collection
    m_Contexts.Clear
    ' release callback implementor
    Set m_StatusCallback = Nothing
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Properties
' ***************************************************************************************
Public Property Get UserAgent() As String
On Error GoTo hell
    UserAgent = m_UserAgent
    Exit Property
hell:
End Property
Public Property Let UserAgent(strUserAgent As String)
On Error GoTo hell
    m_UserAgent = strUserAgent
    Exit Property
hell:
End Property
Public Property Get AccessType() As InternetAccessTypes
On Error GoTo hell
    AccessType = m_AccessType
    Exit Property
hell:
End Property
Public Property Let AccessType(argAccessType As InternetAccessTypes)
On Error GoTo hell
    m_AccessType = argAccessType
    Exit Property
hell:
End Property
Public Property Get Proxy() As String
On Error GoTo hell
    Proxy = m_Proxy
    Exit Property
hell:
End Property
Public Property Let Proxy(strProxy As String)
On Error GoTo hell
    m_Proxy = strProxy
    Exit Property
hell:
End Property
Public Property Get ProxyBypass() As String
On Error GoTo hell
    ProxyBypass = m_ProxyByPass
    Exit Property
hell:
End Property
Public Property Let ProxyBypass(strProxyBypass As String)
On Error GoTo hell
    m_ProxyByPass = strProxyBypass
    Exit Property
hell:
End Property
Public Property Get AccessFlags() As InternetAccessFlags
On Error GoTo hell
    AccessFlags = m_AccessFlags
    Exit Property
hell:
End Property
Public Property Let AccessFlags(argFlags As InternetAccessFlags)
On Error GoTo hell
    m_AccessFlags = argFlags
    Exit Property
hell:
End Property
Public Property Get Handle() As Long
On Error GoTo hell
    Handle = m_Handle
    Exit Property
hell:
End Property
Public Property Get Offline() As Boolean
On Error GoTo hell
    Offline = CBool(InetIsOffline(0))
    Exit Property
hell:
End Property
Public Property Get FtpServers() As NFtpServers
On Error GoTo hell
    Set FtpServers = m_FtpServers
    Exit Property
hell:
End Property



' ***************************************************************************************
' Methods
' ***************************************************************************************
Public Function AttemptConnect() As Boolean
    AttemptConnect = (InternetAttemptConnect(0) = 0)
    If AttemptConnect = False Then
        Me.Disconnect
    End If
End Function
Public Sub Connect()
    If m_AccessType = InternetAccessTypes.Proxy And m_Proxy = "" Then InternetRaiseError InternetBadProxyConfig
On Error GoTo hell
    If m_Handle = 0 Then
        If m_AccessType <> InternetAccessTypes.Proxy Then
            m_Handle = MApiInternet.InternetOpen(m_UserAgent, m_AccessType, vbNullString, vbNullString, m_AccessFlags)
        ElseIf m_ProxyByPass = "" Then
            m_Handle = MApiInternet.InternetOpen(m_UserAgent, m_AccessType, m_Proxy, vbNullString, m_AccessFlags)
        Else
            m_Handle = MApiInternet.InternetOpen(m_UserAgent, m_AccessType, m_Proxy, m_ProxyByPass, m_AccessFlags)
        End If
        ' set up callback
        If m_Handle <> 0 Then
            Dim ret As Long
            ret = InternetSetStatusCallback(m_Handle, AddressOf MInet.InternetStatusCallback)
        End If
    End If
    Exit Sub
hell:
End Sub
Public Sub Disconnect()
On Error GoTo hell
    ' close all FTP connections
    Dim server As CFtpServer
    For Each server In m_FtpServers
        server.Disconnect
    Next server
    ' close internet connection
    If m_Handle <> 0 Then
        InternetSetStatusCallback m_Handle, 0&
        InternetCloseHandle m_Handle
        m_Handle = 0
    End If
    Exit Sub
hell:
End Sub
Public Sub ShouldDisconnect()
On Error GoTo hell
    ' check open FTP connections
    Dim server As CFtpServer
    For Each server In m_FtpServers
        If server.Handle <> 0 Then
            Exit Sub
        End If
    Next server
    ' close internet connection
    If m_Handle <> 0 Then
        InternetSetStatusCallback m_Handle, 0&
        InternetCloseHandle m_Handle
        m_Handle = 0
    End If
    Exit Sub
hell:
End Sub
Public Function Persist(ByVal sFile As String) As Boolean
On Error GoTo hell
    Dim doc As CXMLDocument, server As CFtpServer
    Set doc = New CXMLDocument
    doc.CreateNew "vbinet"
    If doc.IsWellFormed = True Then
        For Each server In m_FtpServers
            server.Persist doc.Root
        Next server
        Persist = doc.SaveToFile(sFile)
    End If
    Exit Function
hell:
End Function
Public Function UnPersist(ByVal sFile As String) As Boolean
On Error GoTo hell
    Dim doc As CXMLDocument, xn As CXMLNode, locator As CUrl
    Set doc = New CXMLDocument
    doc.CreateFromFile sFile
    If doc.IsWellFormed = True Then
        If doc.Root.Name = "vbinet" Then
            For Each xn In doc.Root.SubNodes
                If xn.Name = "ftpserver" Then
                    m_FtpServers.AddFromXmlNode xn
                End If
            Next xn
            UnPersist = True
        End If
    End If
    Exit Function
hell:
End Function


' ***************************************************************************************
' Dialogs
' ***************************************************************************************
Public Function ShowConnectionDialog() As Boolean
On Error GoTo hell
    Dim cd As FConnectDialog
    Set cd = New FConnectDialog
    cd.Create Me
    cd.Show vbModal
    Unload cd
    ShowConnectionDialog = Not cd.Cancelled
    Exit Function
hell:
End Function
Public Function ShowFtpServersDialog(Optional ByVal fAllowConnect As Boolean) As CFtpServer
On Error GoTo hell
    Dim sd As FServersDialog
    Set sd = New FServersDialog
    sd.Create Me.FtpServers, fAllowConnect
    sd.Show vbModal
    Set ShowFtpServersDialog = sd.SelectedServer
    Unload sd
    Exit Function
hell:
End Function


' ***************************************************************************************
' Callbacks
' ***************************************************************************************
Friend Sub InetStatusCallback(ByVal status As CStatusInfo)
On Error GoTo hell
    ' inet notification
    If Not Me.StatusCallback Is Nothing Then Me.StatusCallback.InetStatus status
    ' map callbacks to server
    If Not status.Context.FtpServer Is Nothing Then
        status.Context.FtpServer.InetStatusCallback status
    End If
    Exit Sub
hell:
End Sub
Friend Property Get Contexts() As NContexts
On Error GoTo hell
    Set Contexts = m_Contexts
    Exit Property
hell:
End Property
Public Property Get StatusCallback() As IStatusCallback
On Error GoTo hell
    Set StatusCallback = m_StatusCallback
    Exit Property
hell:
End Property
Public Property Set StatusCallback(argStatusCallback As IStatusCallback)
On Error GoTo hell
    Set m_StatusCallback = argStatusCallback
    Exit Property
hell:
End Property



