Attribute VB_Name = "MApiInternet"
Option Explicit


' ***************************************************************************************
' Declares
' ***************************************************************************************
Public Declare Function GetLastError Lib "kernel32.dll" () As Long
Public Declare Function InternetSetStatusCallback Lib "wininet.dll" (ByVal hInet As Long, ByVal fn As Long) As Long
Public Declare Function InternetGetLastResponseInfo Lib "wininet.dll" Alias "InternetGetLastResponseInfoA" (ByRef dwError As Long, ByVal szBuffer As String, ByRef dwBufferLength As Long) As Long
Public Declare Function InternetAttemptConnect Lib "wininet.dll" (ByVal dwReserved As Long) As Long
Public Declare Function InetIsOffline Lib "Url.dll" (ByVal dwFlags As Long) As Long
Public Declare Function InternetCreateUrl Lib "wininet.dll" Alias "InternetCreateUrlA" (ByRef uc As TUrlComponents, ByVal dwFlags As InternetCreateUrlFlags, ByVal szUrl As String, ByRef dwUrlLength As Long) As Long
Public Declare Function InternetCrackUrl Lib "wininet.dll" Alias "InternetCrackUrlA" (ByVal szUrl As String, ByVal dwUrlLength As Long, ByVal dwFlags As InternetCrackUrlFlags, ByRef uc As TUrlComponents) As Long
Public Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" (ByVal szAgent As String, ByVal dwAccessType As InternetAccessTypes, ByVal szProxyName As String, ByVal szProxyByPass As String, ByVal dwFlags As InternetAccessFlags) As Long
Public Declare Function InternetCloseHandle Lib "wininet.dll" (ByVal hInet As Long) As Long
Public Declare Function InternetConnect Lib "wininet.dll" Alias "InternetConnectA" (ByVal hInet As Long, ByVal szServerName As String, ByVal dwPort As InternetPorts, ByVal szUserName As String, ByVal szPassword As String, ByVal dwService As InternetServices, ByVal dwFlags As InternetFlags, ByVal dwContext As Long) As Long
Public Declare Function FtpFindFirstFile Lib "wininet.dll" Alias "FtpFindFirstFileA" (ByVal hFtp As Long, ByVal szMatch As String, ByRef fd As TWin32FindData, ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Public Declare Function InternetFindNextFile Lib "wininet.dll" Alias "InternetFindNextFileA" (ByVal hFind As Long, ByRef fd As TWin32FindData) As Long
Public Declare Function FtpSetCurrentDirectory Lib "wininet.dll" Alias "FtpSetCurrentDirectoryA" (ByVal hFtp As Long, ByVal szDirectory As String) As Long
Public Declare Function FtpGetFile Lib "wininet.dll" Alias "FtpGetFileA" (ByVal hFtp As Long, ByVal szRemoteFile As String, ByVal szNewFile As String, ByVal fFailIfExists As ApiBool, ByVal dwLocalFlagsAndAttribs As Long, ByVal dwFlags As InternetFlags, ByVal dwContext As Long) As Long
Public Declare Function FtpPutFile Lib "wininet.dll" Alias "FtpPutFileA" (ByVal hFtp As Long, ByVal szLocalFile As String, ByVal szRemoteFile As String, ByVal dwFlags As InternetFlags, ByVal dwContext As Long) As Long
Public Declare Function FtpOpenFile Lib "wininet.dll" Alias "FtpOpenFileA" (ByVal hFtp As Long, ByVal szFileName As String, ByVal dwAccess As FtpFileAccessModes, ByVal dwFlags As InternetFlags, ByVal dwContext As Long) As Long
Public Declare Function InternetReadFileBin Lib "wininet.dll" Alias "InternetReadFileA" (ByVal hFile As Long, ByRef abBuffer As Byte, ByVal cbToRead As Long, ByVal cbRead As Long) As Long
Public Declare Function InternetReadFileStr Lib "wininet.dll" Alias "InternetReadFileA" (ByVal hFile As Long, ByVal szBuffer As String, ByVal cbToRead As Long, ByVal cbRead As Long) As Long
Public Declare Function InternetWriteFileBin Lib "wininet.dll" Alias "InternetWriteFileA" (ByVal hFile As Long, ByRef abBuffer As Byte, ByVal cbToWrite As Long, ByVal cbWritten As Long) As Long
Public Declare Function InternetWriteFileStr Lib "wininet.dll" Alias "InternetWriteFileA" (ByVal hFile As Long, ByVal szBuffer As String, ByVal cbToWrite As Long, ByVal cbWritten As Long) As Long
Public Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal szPath As String, ByVal dwAttribs As Long, ByRef fi As TSHFileInfo, ByVal cb As Long, ByVal Flags As SHGFI) As Long
Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef dest As Any, ByRef source As Any, ByVal cb As Long)


' ***************************************************************************************
' Constants
' ***************************************************************************************
Public Enum SHGFI
    SmallIcon = &H1
    LargeIcon = &H0
    OpenIcon = &H2
    SysIconIndex = &H4000
    UseFileAttributes = &H10
End Enum
Public Enum ApiBool
    ApiFalse = 0
    ApiTrue = 1
End Enum
Public Const SLASH As String = "/"
Public Const DOT As String = "."
Public Const DOTS As String = ".."
Public Const WILDCARD As String = "*"
Public Const WILDCARD_EXT As String = "*.*"
Public Const PROT_FTP As String = "ftp://"


' ***************************************************************************************
' Structures
' ***************************************************************************************
Public Type TUrlComponents
    dwStructSize As Long
    szScheme As String
    dwSchemeLength As Long
    nScheme As InternetSchemes
    szHostName As String
    dwHostNameLength As Long
    nPort As InternetPorts
    szUserName As String
    dwUserNameLength As Long
    szPassword As String
    dwPasswordLength As Long
    szUrlPath As String
    dwUrlPathLength As Long
    szExtraInfo As String
    dwExtraInfoLength As Long
End Type
Public Type TFileTime
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
Public Type TWin32FindData
    dwFileAttributes As FileAttributes
    ftCreationTime As TFileTime
    ftLastAccessTime As TFileTime
    ftLastWriteTime As TFileTime
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    szFileName As String * 260
    szAlternate As String * 14
End Type
Public Type TSHFileInfo
    hIcon As Long
    iIcon As Long
    dwAttribs As Long
    szDisplayName As String * 260
    szTypeName As String * 80
End Type
Public Type TInternetAsyncResult
    dwResult As Long
    dwError As Long
End Type


' ***************************************************************************************
' Utilities
' ***************************************************************************************
Public Function NullTrim(ByVal s As String) As String
On Error GoTo hell
    Dim iNullChar As Long: iNullChar = InStr(1, s, vbNullChar, vbBinaryCompare)
    NullTrim = Mid$(s, 1, iNullChar - 1)
    Exit Function
hell:
End Function
Public Function GetSystemIconIndex(ByVal sPath As String, Optional ByVal fOpen As Boolean = False, Optional ByVal fLarge As Boolean = False, Optional ByVal fUseAttribs = False) As Long
On Error GoTo hell
    Dim Flags As SHGFI
    Flags = SHGFI.SysIconIndex
    If fUseAttribs = True Then
        Flags = Flags Or SHGFI.UseFileAttributes
    End If
    If fOpen = True Then
        Flags = Flags Or SHGFI.OpenIcon
    End If
    If fLarge = True Then
        Flags = Flags Or SHGFI.LargeIcon
    End If
    Dim fi As TSHFileInfo
    Call SHGetFileInfo(sPath, 0, fi, LenB(fi), Flags)
    GetSystemIconIndex = fi.iIcon
    Exit Function
hell:
End Function
Public Sub PathAppend(ByRef sPath As String, ByVal sMore As String)
    PathAssertEndSlash sPath
    sPath = sPath & sMore
    Exit Sub
hell:
End Sub
Public Sub PathAssertEndSlash(ByRef sPath As String)
On Error GoTo hell
    If Right$(sPath, 1) <> SLASH Then sPath = sPath & SLASH
    Exit Sub
hell:
End Sub


