Attribute VB_Name = "MInet"
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

' the official reference to the one and only internet connection
Private m_InetConnection As CInetConnection

' context ID counter
Private m_LastContextID As Long


' ***************************************************************************************
' Global properties
' ***************************************************************************************
Public Property Get InetConnection() As CInetConnection
On Error GoTo hell
    If m_InetConnection Is Nothing Then
        Set m_InetConnection = New CInetConnection
    End If
    Set InetConnection = m_InetConnection
    Exit Property
hell:
End Property
Public Sub Dispose()
On Error GoTo hell
    Set m_InetConnection = Nothing
    m_LastContextID = 0
    Exit Sub
hell:
End Sub


' ***************************************************************************************
' Callbacks and context
' ***************************************************************************************
Public Sub InternetStatusCallback(ByVal hInet As Long, ByVal dwContext As Long, ByVal dwInternetStatus As InternetStates, ByVal lpvStatusInfo As Long, ByVal dwStatusInfoLength As Long)
On Error GoTo hell
    ' create info object
    Dim status As New CStatusInfo, ctxt As CContext
    Set ctxt = InetConnection.Contexts.Item(dwContext)
    status.Create hInet, ctxt, dwInternetStatus, lpvStatusInfo, dwStatusInfoLength
    ' call internet connection (will pass it on)
    InetConnection.InetStatusCallback status
    Exit Sub
hell:
End Sub
Public Function GetNewContextID() As Long
On Error GoTo hell
    m_LastContextID = m_LastContextID + 1
    GetNewContextID = m_LastContextID
    Exit Function
hell:
End Function


' ***************************************************************************************
' Errors
' ***************************************************************************************
Public Sub InternetRaiseError(ByVal e As InternetErrors)
    Dim sMsg As String
    Select Case e
        Case InternetErrors.InternetNotConnected
            sMsg = "Internet not connected"
        Case InternetErrors.InternetServicesInaccessible
            sMsg = "Internet services inaccessible"
        Case InternetErrors.InternetBadProxyConfig
            sMsg = "No proxy server provided"
        Case InternetErrors.FtpServerNotConnected
            sMsg = "FTP Server not connected"
        Case InternetErrors.UrlUserNameNeeded
            sMsg = "Must provide a user name"
        Case InternetErrors.FtpServerInvalidProtocol
            sMsg = "Invalid protocol for FTP server"
        Case InternetErrors.FtpFolderOperationFailed
            sMsg = "Operation on FTP folder failed"
        Case InternetErrors.FtpServerHostNotUnique
            sMsg = "FTP server must have a unique host"
    End Select
    Err.Raise vbObjectError Or e, , sMsg
End Sub
Public Function InternetGetErrorCode(ByVal e As ErrObject) As InternetErrors
    InternetGetErrorCode = e.Number Xor vbObjectError
End Function
Public Function TranslateErrorCode(ByVal dwErrorCode As Long) As String
On Error GoTo hell
    ' from MSDN
    Dim sBuffer As String, nBuffer As Long
    Select Case dwErrorCode
        Case 12001: TranslateErrorCode = "No more handles could be generated at this time"
        Case 12002: TranslateErrorCode = "The request has timed out."
        Case 12003:
            'extended error returned from the server
            sBuffer = Space$(256)
            nBuffer = Len(sBuffer)
            If InternetGetLastResponseInfo(dwErrorCode, sBuffer, nBuffer) Then
               TranslateErrorCode = NullTrim(sBuffer)
            Else
               TranslateErrorCode = "Extended error returned from server."
            End If
        Case 12004: TranslateErrorCode = "An internal error has occurred."
        Case 12005: TranslateErrorCode = "The URL is invalid."
        Case 12006: TranslateErrorCode = "The URL scheme could not be recognized, or is not supported."
        Case 12007: TranslateErrorCode = "The server name could not be resolved."
        Case 12008: TranslateErrorCode = "The requested protocol could not be located."
        Case 12009: TranslateErrorCode = "A request to InternetQueryOption or InternetSetOption specified an invalid option value."
        Case 12010: TranslateErrorCode = "The length of an option supplied to InternetQueryOption or InternetSetOption is incorrect for the type of option specified."
        Case 12011: TranslateErrorCode = "The request option can not be set, only queried. "
        Case 12012: TranslateErrorCode = "The Win32 Internet support is being shutdown or unloaded."
        Case 12013: TranslateErrorCode = "The request to connect and login to an FTP server could not be completed because the supplied user name is incorrect."
        Case 12014: TranslateErrorCode = "The request to connect and login to an FTP server could not be completed because the supplied password is incorrect. "
        Case 12015: TranslateErrorCode = "The request to connect to and login to an FTP server failed."
        Case 12016: TranslateErrorCode = "The requested operation is invalid. "
        Case 12017: TranslateErrorCode = "The operation was canceled, usually because the handle on which the request was operating was closed before the operation completed."
        Case 12018: TranslateErrorCode = "The type of handle supplied is incorrect for this operation."
        Case 12019: TranslateErrorCode = "The requested operation can not be carried out because the handle supplied is not in the correct state."
        Case 12020: TranslateErrorCode = "The request can not be made via a proxy."
        Case 12021: TranslateErrorCode = "A required registry value could not be located. "
        Case 12022: TranslateErrorCode = "A required registry value was located but is an incorrect type or has an invalid value."
        Case 12023: TranslateErrorCode = "Direct network access cannot be made at this time. "
        Case 12024: TranslateErrorCode = "An asynchronous request could not be made because a zero context value was supplied."
        Case 12025: TranslateErrorCode = "An asynchronous request could not be made because a callback function has not been set."
        Case 12026: TranslateErrorCode = "The required operation could not be completed because one or more requests are pending."
        Case 12027: TranslateErrorCode = "The format of the request is invalid."
        Case 12028: TranslateErrorCode = "The requested item could not be located."
        Case 12029: TranslateErrorCode = "The attempt to connect to the server failed."
        Case 12030: TranslateErrorCode = "The connection with the server has been terminated."
        Case 12031: TranslateErrorCode = "The connection with the server has been reset."
        Case 12036: TranslateErrorCode = "The request failed because the handle already exists."
        Case Else: TranslateErrorCode = "Error details not available."
   End Select
   Exit Function
hell:
End Function

